package com.its.op.service.its.road;

import com.its.op.dao.repository.its.road.TbRoadRepository;
import com.its.op.dto.its.road.TbRoadDto;
import com.its.op.entity.its.road.TbRoad;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbRoadService {

    private final TbRoadRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbRoad requireOne(Long id) throws NoSuchElementException {
        Optional<TbRoad> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    /**
     * 모든 정보 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbRoadDto> findAll() {
        List<TbRoadDto> result = new ArrayList<>();
        List<TbRoad> data = this.repo.findAll();
        for (TbRoad entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    /**
     * 삭제되지 않은 정보 조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbRoadDto> findAllList() {
        List<TbRoadDto> result = new ArrayList<>();
        List<TbRoad> data = this.repo.findAllList();
        for (TbRoad entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 지역센터 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbRoadDto> findLocalAll() {
        List<TbRoadDto> result = new ArrayList<>();
        List<TbRoad> data = this.repo.findAll();
        for (TbRoad entity : data) {
            if (("LAT001").equals(entity.getAreaCd())) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbRoadDto findById(Long id) {
        TbRoad entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbRoadDto updateById(Long id, TbRoadDto.TbRoadUpdReq req) {
        TbRoad entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbRoadDto> mergeInfoList(List<TbRoadDto.TbRoadUpdReq> reqList) {
        List<TbRoadDto> result = new ArrayList<>();
        for (TbRoadDto.TbRoadUpdReq req : reqList) {
            TbRoad obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbRoadDto mergeInfo(TbRoadDto.TbRoadUpdReq req) {
        TbRoad obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbRoadDto deleteById(Long id) {
        TbRoad entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbRoadDto> deleteByIds(List<Long> ids) {
        List<TbRoadDto> result = new ArrayList<>();
        for (Long id : ids) {
            Optional<TbRoad> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }


    /**
     * 지도검색
     * @param filter
     * @return
     */
    public List<TbRoadDto> findByFilter(String filter) {
        List<TbRoadDto> result = new ArrayList<>();
        List<TbRoad> data = this.repo.findAll();
        data.forEach(obj -> {
            if (("Y").equals(obj.getDelYn())) {
                return;
            }
            if (filter == null || filter.isEmpty()) {
                result.add(obj.toDto());
            } else {
                if ((obj.getRoadNm() != null && obj.getRoadNm().contains(filter)) || String.valueOf(obj.getRoadId()).contains(filter)) {
                    result.add(obj.toDto());
                }
            }
        });
        return result;
    }

    // 이름 변경
    @Transactional
    public TbRoadDto updateNameById(Long id, TbRoadDto.TbRoadNameUpdReq req) {
        TbRoad entity = requireOne(id);
        entity.updateName(req);
        this.repo.save(entity);
        return entity.toDto();
    }
    public TbRoadDto updateSectGradById(Long id, TbRoadDto.TbRoadSectGradUpdReq req) {
        TbRoad entity = requireOne(id);
        entity.updateSectGrad(req);
        this.repo.save(entity);
        return entity.toDto();
    }
}
